<template>
  <input
    v-show="false"
    ref="fileInputRef"
    name="file"
    type="file"
    @change="onChangeFile"
  />
  <slot
    @click="openFileManager"
    @keydown.enter="openFileManager"
  />
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { UploadApiService } from '@/api';

const emits = defineEmits<{
  (event: 'file-upload', src: string): void;
}>();

const fileInputRef = ref<HTMLInputElement | null>(null);

const openFileManager = () => {
  if (!fileInputRef.value) return;

  fileInputRef.value.click();
};

const onChangeFile = async (event: Event | undefined) => {
  if (event === undefined) return;

  const element = event.target as HTMLInputElement;

  if (element.files === null) return;

  const form = new FormData();

  form.append('file', element.files[0]);

  try {
    const uploadedFileSrc = await UploadApiService.uploadFile(form);

    if (uploadedFileSrc.status === 201) {
      emits('file-upload', uploadedFileSrc.data);
    }
  } catch (error) {
    console.log('File-upload: ', error);
  }
};
</script>
